unit CrtX; {pro Turbo Pascal 7.0 - verze 4/99}

{ NEJPOUVANJ funkce z unitu Crt v pouiteln podob:

  Obsahuje: - ReadKey a KeyPressed (s podporou klves F11 a F12)
            - Sound a NoSound
            - ClrScr
            - Delay (funkn i na rychlch mainch)

  Testovno: troku :-)

  Pehled zmn: 4/99 pidna fce ClrScr a var TextAttr
                5/98 pidny Sound, NoSound a Delay
                6/97 zkladn verze (ReadKey a KeyPressed)

Ŀ
 UPOZORNN: Tento soubor je PUBLIC DOMAIN, take si s nm mete dlat, 
 co chcete (teba vytisknout a povsit na ze:-), ale NA VLASTN RIZIKO. 


                                  Michal Jungmann <jungmann@braillnet.cz> }

interface {***************************************************************}

function ReadKey: Char;
function KeyPressed: Boolean;

procedure Sound(freq: Word); {freq in Hz}
procedure NoSound;

var TextAttr: Byte;
procedure ClrScr;

procedure Delay(time: Word); {time in ms}

implementation {**********************************************************}

const LastKey: Byte = 0;
function ReadKey: Char; assembler;
asm
 cmp LastKey, 00
 jz @Read
 mov AL, LastKey
 mov LastKey, 00
 jmp @End
@Read:
 mov AH, $10
 int $16
 cmp AL, 224
 jnz @Next
 cmp AH, 00
 jz @Next
 xor AL, AL
@Next:
 or AL, AL
 jnz @End
 mov LastKey, AH
@End:
end; {ReadKey}

function KeyPressed: Boolean; assembler;
asm
 mov AH, $11
 int $16
 mov AL, 0
 jz @End
 inc AL
@End:
end; {KeyPressed}

procedure Sound(freq: Word); assembler;
asm
 push AX
 push DX
 pushf
 mov AL, $B6
 out $43, AL
 mov DX, $0012
 mov AX, $34DC
 div freq
 out $42, AL
 mov AL, AH
 out $42, AL
 in AL, $61
 or AL, 03
 out $61, AL
 popf
 pop DX
 pop AX
end; {Sound}

procedure NoSound; assembler;
asm
 push AX
 pushf
 in AL, $61
 and AL, $FC
 out $61, AL
 popf
 pop AX
end; {NoSound}

procedure ClrScr; assembler;
asm
 mov AX, $0600 {sma obrazovku}
 mov BH, TextAttr {barva}
 mov CX, 0000 {lev horn roh}
 mov ES, CX {sem se to tak hod :-}
 mov DH, [ES:$0484] {poet dek}
 mov DL, [ES:$044A] {poet sloupc}
 int $10 {prove}
 mov AH, 02 {nastav kurzor}
 mov BH, 00 {strana}
 mov DX, 0000 {lev horn roh}
 int $10 {prove}
end; {ClrScr}

{$S-}
procedure DelayLoop; assembler;
asm
@Begin:
 sub AX, 0001
 sbb DX, 0000
 jb @End
 cmp BL, [ES:DI]
 jz @Begin
@End:
end; {DelayLoop}

var delayCnt, delayCntHi: Word;
procedure Delay(time: Word); assembler;
asm
 mov CX, time
 jcxz @End
 xor DI, DI
 mov ES, DI
 mov BL, [ES:DI]
@Loop:
 mov AX, delayCnt
 mov DX, delayCntHi
 call DelayLoop
 loop @Loop
@End:
end; {Delay}

begin {startup code}
 asm {for Delay}
  xor AX, AX
  mov ES, AX
  mov DI, $046C
  mov BL, [ES:DI]
@Loop:
  cmp BL, [ES:DI]
  jz @Loop
  mov BL, [ES:DI]
  mov AX, $FFE4
  cwd
  call DelayLoop
  not AX
  not DX
  mov CX, 55
  mov BX, AX
  mov AX, DX
  xor DX, DX
  div CX
  mov delayCntHi, AX
  mov AX, BX
  div CX
  mov delayCnt, AX
 end; {asm}
{$S+}
 if mem[0:$0449] = 3 then TextAttr:= $1E {reim 80x25 -> lut na modr}
 else TextAttr:= $07; {ostatn -> ed na ern}
end. {of unit}